/* A Bison parser, made by GNU Bison 3.3.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2019 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Undocumented macros, especially those whose name start with YY_,
   are private implementation details.  Do not rely on them.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.3.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 1 "cfparse.y" /* yacc.c:337  */

/*
 * Configuration file parser for mrouted.
 *
 * Written by Bill Fenner, NRL, 1994
 *
 * cfparse.y,v 3.8.4.30 1998/03/01 01:48:58 fenner Exp
 */
#include <stdio.h>
#include <stdarg.h>
#include "defs.h"
#include <netdb.h>
#include <ifaddrs.h>

/*
 * Local function declarations
 */
static void        fatal(const char *fmt, ...);
static void        warn(const char *fmt, ...);
static void        yyerror(char *s);
static char       *next_word(void);
static int         yylex(void);
static uint32_t    valid_if(char *s);
static const char *ifconfaddr(uint32_t addr);
int                yyparse(void);

static FILE *fp;

char *configfilename = _PATH_MROUTED_CONF;

extern int cache_lifetime;
extern int prune_lifetime;

int allow_black_holes = 0;

static int lineno;

static struct uvif *v;
static struct uvif scrap;

static int order, state;
static int noflood = 0;
static int rexmit = VIFF_REXMIT_PRUNES;

struct addrmask {
	uint32_t addr;
	int mask;
};

struct boundnam {
	char		*name;
	struct addrmask	 bound;
};

#define MAXBOUNDS 20

struct boundnam boundlist[MAXBOUNDS];	/* Max. of 20 named boundaries */
int numbounds = 0;			/* Number of named boundaries */


#line 131 "cfparse.c" /* yacc.c:337  */
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif


/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    CACHE_LIFETIME = 258,
    PRUNE_LIFETIME = 259,
    PRUNING = 260,
    BLACK_HOLE = 261,
    NOFLOOD = 262,
    QUERY_INTERVAL = 263,
    IGMP_ROBUSTNESS = 264,
    NO = 265,
    PHYINT = 266,
    TUNNEL = 267,
    NAME = 268,
    DISABLE = 269,
    ENABLE = 270,
    IGMPV1 = 271,
    IGMPV2 = 272,
    IGMPV3 = 273,
    SRCRT = 274,
    BESIDE = 275,
    METRIC = 276,
    THRESHOLD = 277,
    RATE_LIMIT = 278,
    BOUNDARY = 279,
    NETMASK = 280,
    ALTNET = 281,
    ADVERT_METRIC = 282,
    FILTER = 283,
    ACCEPT = 284,
    DENY = 285,
    EXACT = 286,
    BIDIR = 287,
    REXMIT_PRUNES = 288,
    REXMIT_PRUNES2 = 289,
    PASSIVE = 290,
    ALLOW_NONPRUNERS = 291,
    NOTRANSIT = 292,
    BLASTER = 293,
    FORCE_LEAF = 294,
    ROUTER_ALERT = 295,
    PRUNE_LIFETIME2 = 296,
    NOFLOOD2 = 297,
    SYSNAM = 298,
    SYSCONTACT = 299,
    SYSVERSION = 300,
    SYSLOCATION = 301,
    BOOLEAN = 302,
    NUMBER = 303,
    STRING = 304,
    ADDRMASK = 305,
    ADDR = 306
  };
#endif
/* Tokens.  */
#define CACHE_LIFETIME 258
#define PRUNE_LIFETIME 259
#define PRUNING 260
#define BLACK_HOLE 261
#define NOFLOOD 262
#define QUERY_INTERVAL 263
#define IGMP_ROBUSTNESS 264
#define NO 265
#define PHYINT 266
#define TUNNEL 267
#define NAME 268
#define DISABLE 269
#define ENABLE 270
#define IGMPV1 271
#define IGMPV2 272
#define IGMPV3 273
#define SRCRT 274
#define BESIDE 275
#define METRIC 276
#define THRESHOLD 277
#define RATE_LIMIT 278
#define BOUNDARY 279
#define NETMASK 280
#define ALTNET 281
#define ADVERT_METRIC 282
#define FILTER 283
#define ACCEPT 284
#define DENY 285
#define EXACT 286
#define BIDIR 287
#define REXMIT_PRUNES 288
#define REXMIT_PRUNES2 289
#define PASSIVE 290
#define ALLOW_NONPRUNERS 291
#define NOTRANSIT 292
#define BLASTER 293
#define FORCE_LEAF 294
#define ROUTER_ALERT 295
#define PRUNE_LIFETIME2 296
#define NOFLOOD2 297
#define SYSNAM 298
#define SYSCONTACT 299
#define SYSVERSION 300
#define SYSLOCATION 301
#define BOOLEAN 302
#define NUMBER 303
#define STRING 304
#define ADDRMASK 305
#define ADDR 306

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 63 "cfparse.y" /* yacc.c:352  */

	int num;
	char *ptr;
	struct addrmask addrmask;
	uint32_t addr;
	struct vf_element *filterelem;

#line 281 "cfparse.c" /* yacc.c:352  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE yylval;

int yyparse (void);





#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && ! defined __ICC && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   100

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  52
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  20
/* YYNRULES -- Number of rules.  */
#define YYNRULES  85
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  103

#define YYUNDEFTOK  2
#define YYMAXUTOK   306

/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                                \
  ((unsigned) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,    95,    95,    98,    99,   102,   103,   111,   110,   132,
     131,   194,   201,   208,   213,   217,   221,   232,   245,   257,
     268,   279,   283,   287,   291,   295,   301,   309,   310,   313,
     314,   318,   325,   331,   332,   335,   336,   337,   338,   339,
     340,   341,   353,   357,   382,   386,   390,   399,   405,   409,
     415,   419,   425,   429,   435,   439,   457,   461,   465,   472,
     476,   480,   484,   489,   493,   500,   527,   531,   558,   562,
     572,   576,   584,   588,   614,   618,   634,   647,   648,   651,
     652,   655,   656,   659,   660,   663
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "CACHE_LIFETIME", "PRUNE_LIFETIME",
  "PRUNING", "BLACK_HOLE", "NOFLOOD", "QUERY_INTERVAL", "IGMP_ROBUSTNESS",
  "NO", "PHYINT", "TUNNEL", "NAME", "DISABLE", "ENABLE", "IGMPV1",
  "IGMPV2", "IGMPV3", "SRCRT", "BESIDE", "METRIC", "THRESHOLD",
  "RATE_LIMIT", "BOUNDARY", "NETMASK", "ALTNET", "ADVERT_METRIC", "FILTER",
  "ACCEPT", "DENY", "EXACT", "BIDIR", "REXMIT_PRUNES", "REXMIT_PRUNES2",
  "PASSIVE", "ALLOW_NONPRUNERS", "NOTRANSIT", "BLASTER", "FORCE_LEAF",
  "ROUTER_ALERT", "PRUNE_LIFETIME2", "NOFLOOD2", "SYSNAM", "SYSCONTACT",
  "SYSVERSION", "SYSLOCATION", "BOOLEAN", "NUMBER", "STRING", "ADDRMASK",
  "ADDR", "$accept", "conf", "stmts", "stmt", "$@1", "$@2", "tunnelmods",
  "tunnelmod", "ifmods", "ifmod", "mod", "interface", "addrname", "bound",
  "boundary", "addrmask", "filter", "filtlist", "filtelement", "filtelem", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306
};
# endif

#define YYPACT_NINF -39

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-39)))

#define YYTABLE_NINF -3

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int8 yypact[] =
{
     -39,    24,     0,   -39,   -39,   -23,   -22,   -20,   -39,   -39,
     -19,   -18,    -9,   -35,   -35,   -21,   -15,   -13,   -14,   -12,
     -11,   -10,   -39,   -39,   -39,   -39,   -39,   -39,   -39,   -39,
     -39,   -39,   -39,   -34,    -8,   -39,   -39,   -39,   -39,   -39,
     -39,   -39,   -39,   -39,   -39,   -39,   -39,    33,   -39,   -39,
     -39,   -39,   -39,   -39,    -7,     4,     5,   -31,   -34,   -30,
      13,   -27,   -27,   -39,    17,   -39,   -39,   -39,   -39,    19,
      25,   -39,   -39,   -39,    57,   -39,   -39,   -39,   -39,   -39,
     -39,   -39,   -39,   -39,   -39,   -39,   -39,   -39,   -39,   -39,
      32,    52,   -39,   -39,   -39,   -39,   -39,    38,   -39,   -39,
     -39,   -39,   -39
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       3,     0,     0,     1,     5,     0,     0,     0,    16,    17,
       0,     0,     0,     0,     0,     0,    18,     0,     0,     0,
       0,     0,     4,    11,    12,    13,    25,    26,     6,    14,
      71,    70,     7,     0,     0,    19,    15,    21,    22,    23,
      24,    33,    73,    72,     9,    76,    20,     8,    27,    36,
      37,    38,    39,    40,    50,    48,    54,    56,    42,    44,
      52,    66,    68,    69,    57,    59,    63,    61,    62,    45,
       0,    60,    34,    35,    10,    49,    47,    53,    75,    55,
      74,    41,    77,    78,    43,    51,    80,    85,    65,    79,
      81,    83,    67,    58,    46,    64,    32,    30,    28,    29,
      82,    84,    31
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int8 yypgoto[] =
{
     -39,   -39,   -39,   -39,   -39,   -39,   -39,   -39,   -39,   -39,
     -38,    74,    39,   -39,    43,   -39,    28,     6,   -39,   -39
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int8 yydefgoto[] =
{
      -1,     1,     2,    22,    41,    48,    74,    98,    47,    72,
      73,    32,    44,    79,    46,    84,    88,    89,    90,    91
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int8 yytable[] =
{
      -2,     4,    28,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    30,    42,    31,    43,    78,    45,
      82,    83,    86,    87,     3,    23,    24,    25,    34,    26,
      27,    29,    35,    16,    36,    37,    99,    38,    39,    40,
      17,    75,    45,    18,    19,    20,    21,    49,    50,    51,
      52,    53,    76,    77,    54,    55,    56,    57,    58,    59,
      60,    85,    61,    62,    93,    63,    94,    64,    65,    66,
      67,    68,    69,    95,    70,    71,    96,    97,    54,    55,
      56,    57,    87,   101,    60,   102,    61,    62,    33,    63,
      92,    64,    65,    66,    67,    68,   100,    81,    70,    71,
      80
};

static const yytype_uint8 yycheck[] =
{
       0,     1,    11,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    49,    49,    51,    51,    49,    50,
      50,    51,    49,    50,     0,    48,    48,    47,    49,    48,
      48,    40,    47,    33,    47,    49,    74,    49,    49,    49,
      40,    48,    50,    43,    44,    45,    46,    14,    15,    16,
      17,    18,    48,    48,    21,    22,    23,    24,    25,    26,
      27,    48,    29,    30,    47,    32,    47,    34,    35,    36,
      37,    38,    39,    48,    41,    42,    19,    20,    21,    22,
      23,    24,    50,    31,    27,    47,    29,    30,    14,    32,
      62,    34,    35,    36,    37,    38,    90,    58,    41,    42,
      57
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,    53,    54,     0,     1,     3,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    33,    40,    43,    44,
      45,    46,    55,    48,    48,    47,    48,    48,    11,    40,
      49,    51,    63,    63,    49,    47,    47,    49,    49,    49,
      49,    56,    49,    51,    64,    50,    66,    60,    57,    14,
      15,    16,    17,    18,    21,    22,    23,    24,    25,    26,
      27,    29,    30,    32,    34,    35,    36,    37,    38,    39,
      41,    42,    61,    62,    58,    48,    48,    48,    49,    65,
      66,    64,    50,    51,    67,    48,    49,    50,    68,    69,
      70,    71,    68,    47,    47,    48,    19,    20,    59,    62,
      69,    31,    47
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    52,    53,    54,    54,    55,    55,    56,    55,    57,
      55,    55,    55,    55,    55,    55,    55,    55,    55,    55,
      55,    55,    55,    55,    55,    55,    55,    58,    58,    59,
      59,    59,    59,    60,    60,    61,    61,    61,    61,    61,
      61,    61,    61,    61,    61,    61,    61,    62,    62,    62,
      62,    62,    62,    62,    62,    62,    62,    62,    62,    62,
      62,    62,    62,    62,    62,    62,    62,    62,    62,    62,
      63,    63,    64,    64,    65,    65,    66,    67,    67,    68,
      68,    69,    69,    70,    70,    71
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     0,     2,     1,     2,     0,     4,     0,
       5,     2,     2,     2,     2,     2,     1,     1,     1,     2,
       3,     2,     2,     2,     2,     2,     2,     0,     2,     1,
       1,     2,     1,     0,     2,     1,     1,     1,     1,     1,
       1,     2,     1,     2,     1,     1,     2,     2,     1,     2,
       1,     2,     1,     2,     1,     2,     1,     1,     2,     1,
       1,     1,     1,     1,     2,     2,     1,     2,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     2,     1,     2,     1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YYUSE (yyoutput);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyo, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyo, yytype, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &yyvsp[(yyi + 1) - (yynrhs)]
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            else
              goto append;

          append:
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return (YYSIZE_T) (yystpcpy (yyres, yystr) - yyres);
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
                    yysize = yysize1;
                  else
                    return 2;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
    default: /* Avoid compiler warnings. */
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
      yysize = yysize1;
    else
      return 2;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yynewstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  *yyssp = (yytype_int16) yystate;

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    goto yyexhaustedlab;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = (YYSIZE_T) (yyssp - yyss + 1);

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
# undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 6:
#line 104 "cfparse.y" /* yacc.c:1652  */
    {
	    vifi_t vifi;

	    for (vifi = 0, v = uvifs; vifi < numvifs; ++vifi, ++v)
		v->uv_flags |= VIFF_DISABLED;
	}
#line 1462 "cfparse.c" /* yacc.c:1652  */
    break;

  case 7:
#line 111 "cfparse.y" /* yacc.c:1652  */
    {
	    vifi_t vifi;

	    state++;

	    if (order)
		fatal("phyints must appear before tunnels");

	    for (vifi = 0, v = uvifs; vifi < numvifs; ++vifi, ++v) {
		if (!(v->uv_flags & VIFF_TUNNEL) && (yyvsp[0].addr) == v->uv_lcl_addr)
		    break;
	    }

	    if (vifi == numvifs) {
		if ((yyvsp[0].addr))
			warn("phyint %s not available, continuing ...", inet_fmt((yyvsp[0].addr), s1, sizeof(s1)));
		v = &scrap;
	    }
	}
#line 1486 "cfparse.c" /* yacc.c:1652  */
    break;

  case 9:
#line 132 "cfparse.y" /* yacc.c:1652  */
    {
	    const char *ifname;
	    struct ifreq ffr;
	    vifi_t vifi;

	    order++;

	    ifname = ifconfaddr((yyvsp[-1].addr));
	    if (ifname == 0)
		fatal("Tunnel local address %s is not mine", inet_fmt((yyvsp[-1].addr), s1, sizeof(s1)));

	    if (((ntohl((yyvsp[-1].addr)) & IN_CLASSA_NET) >> IN_CLASSA_NSHIFT) == IN_LOOPBACKNET)
		fatal("Tunnel local address %s is a loopback address", inet_fmt((yyvsp[-1].addr), s1, sizeof(s1)));

	    if (ifconfaddr((yyvsp[0].addr)) != NULL)
		fatal("Tunnel remote address %s is one of mine", inet_fmt((yyvsp[0].addr), s1, sizeof(s1)));

	    for (vifi = 0, v = uvifs; vifi < numvifs; ++vifi, ++v) {
		if (v->uv_flags & VIFF_TUNNEL) {
		    if ((yyvsp[0].addr) == v->uv_rmt_addr)
			fatal("Duplicate tunnel to %s",
			      inet_fmt((yyvsp[0].addr), s1, sizeof(s1)));
		} else if (!(v->uv_flags & VIFF_DISABLED)) {
		    if (((yyvsp[0].addr) & v->uv_subnetmask) == v->uv_subnet)
			fatal("Unnecessary tunnel to %s, same subnet as vif %d (%s)",
			      inet_fmt((yyvsp[0].addr), s1, sizeof(s1)), vifi, v->uv_name);
		}
	    }

	    if (numvifs == MAXVIFS)
		fatal("too many vifs");

	    strlcpy(ffr.ifr_name, ifname, sizeof(ffr.ifr_name));
	    if (ioctl(udp_socket, SIOCGIFFLAGS, (char *)&ffr)<0)
		fatal("ioctl SIOCGIFFLAGS on %s", ffr.ifr_name);

	    v = &uvifs[numvifs];
	    zero_vif(v, 1);
	    v->uv_flags      = VIFF_TUNNEL | rexmit | noflood;
	    v->uv_flags     |= VIFF_OTUNNEL; /* XXX */
	    v->uv_lcl_addr   = (yyvsp[-1].addr);
	    v->uv_rmt_addr   = (yyvsp[0].addr);
	    v->uv_dst_addr   = (yyvsp[0].addr);
	    strlcpy(v->uv_name, ffr.ifr_name, sizeof(v->uv_name));

	    if (!(ffr.ifr_flags & IFF_UP)) {
		v->uv_flags |= VIFF_DOWN;
		vifs_down = TRUE;
	    }
	}
#line 1541 "cfparse.c" /* yacc.c:1652  */
    break;

  case 10:
#line 183 "cfparse.y" /* yacc.c:1652  */
    {
	    if (!(v->uv_flags & VIFF_OTUNNEL))
		init_ipip_on_vif(v);

	    logit(LOG_INFO, 0, "installing tunnel from %s to %s as vif #%u - rate=%d",
		  inet_fmt((yyvsp[-3].addr), s1, sizeof(s1)), inet_fmt((yyvsp[-2].addr), s2, sizeof(s2)),
		  numvifs, v->uv_rate_limit);

	    ++numvifs;

	}
#line 1557 "cfparse.c" /* yacc.c:1652  */
    break;

  case 11:
#line 195 "cfparse.y" /* yacc.c:1652  */
    {
	    if ((yyvsp[0].num) < MIN_CACHE_LIFETIME)
		warn("cache-lifetime %d must be at least %d", (yyvsp[0].num), MIN_CACHE_LIFETIME);
	    else
		cache_lifetime = (yyvsp[0].num);
	}
#line 1568 "cfparse.c" /* yacc.c:1652  */
    break;

  case 12:
#line 202 "cfparse.y" /* yacc.c:1652  */
    {
	    if ((yyvsp[0].num) < MIN_PRUNE_LIFETIME)
		warn("prune-lifetime %d must be at least %d", (yyvsp[0].num), MIN_PRUNE_LIFETIME);
	    else
		prune_lifetime = (yyvsp[0].num);
	}
#line 1579 "cfparse.c" /* yacc.c:1652  */
    break;

  case 13:
#line 209 "cfparse.y" /* yacc.c:1652  */
    {
	    if ((yyvsp[0].num) != 1)
		warn("Disabling pruning is no longer supported");
	}
#line 1588 "cfparse.c" /* yacc.c:1652  */
    break;

  case 14:
#line 214 "cfparse.y" /* yacc.c:1652  */
    {
	    router_alert = 0;
	}
#line 1596 "cfparse.c" /* yacc.c:1652  */
    break;

  case 15:
#line 218 "cfparse.y" /* yacc.c:1652  */
    {
	    router_alert = (yyvsp[0].num);
	}
#line 1604 "cfparse.c" /* yacc.c:1652  */
    break;

  case 16:
#line 222 "cfparse.y" /* yacc.c:1652  */
    {
#ifdef ALLOW_BLACK_HOLES
	    allow_black_holes = 1;
#endif
	}
#line 1614 "cfparse.c" /* yacc.c:1652  */
    break;

  case 17:
#line 233 "cfparse.y" /* yacc.c:1652  */
    {
	    vifi_t vifi;

	    noflood = VIFF_NOFLOOD;
	    for (vifi = 0, v = uvifs; vifi < numvifs; ++vifi, ++v)
		v->uv_flags |= VIFF_NOFLOOD;
	}
#line 1626 "cfparse.c" /* yacc.c:1652  */
    break;

  case 18:
#line 246 "cfparse.y" /* yacc.c:1652  */
    {
	    vifi_t vifi;

	    for (vifi = 0, v = uvifs; vifi < numvifs; ++vifi, ++v)
		v->uv_flags |= VIFF_REXMIT_PRUNES;
	}
#line 1637 "cfparse.c" /* yacc.c:1652  */
    break;

  case 19:
#line 258 "cfparse.y" /* yacc.c:1652  */
    {
	    if ((yyvsp[0].num)) {
		vifi_t vifi;

		for (vifi = 0, v = uvifs; vifi < numvifs; ++vifi, ++v)
		    v->uv_flags |= VIFF_REXMIT_PRUNES;
	    } else {
		rexmit = 0;
	    }
	}
#line 1652 "cfparse.c" /* yacc.c:1652  */
    break;

  case 20:
#line 269 "cfparse.y" /* yacc.c:1652  */
    {
	    size_t len = strlen((yyvsp[-1].ptr)) + 1;

	    if (numbounds >= MAXBOUNDS)
		fatal("Too many named boundaries (max %d)", MAXBOUNDS);

	    boundlist[numbounds].name = malloc(len);
	    strlcpy(boundlist[numbounds].name, (yyvsp[-1].ptr), len);
	    boundlist[numbounds++].bound = (yyvsp[0].addrmask);
	}
#line 1667 "cfparse.c" /* yacc.c:1652  */
    break;

  case 21:
#line 280 "cfparse.y" /* yacc.c:1652  */
    {
	    /* Removed SNMP support */
	}
#line 1675 "cfparse.c" /* yacc.c:1652  */
    break;

  case 22:
#line 284 "cfparse.y" /* yacc.c:1652  */
    {
	    /* Removed SNMP support */
	}
#line 1683 "cfparse.c" /* yacc.c:1652  */
    break;

  case 23:
#line 288 "cfparse.y" /* yacc.c:1652  */
    {
	    /* Removed SNMP support */
	}
#line 1691 "cfparse.c" /* yacc.c:1652  */
    break;

  case 24:
#line 292 "cfparse.y" /* yacc.c:1652  */
    {
	    /* Removed SNMP support */
	}
#line 1699 "cfparse.c" /* yacc.c:1652  */
    break;

  case 25:
#line 296 "cfparse.y" /* yacc.c:1652  */
    {
	    if ((yyvsp[0].num) < 1 || (yyvsp[0].num) > 1024)
		fatal("Invalid IGMP query interval [1,1024]: %d", (yyvsp[0].num));
	    igmp_query_interval = (yyvsp[0].num);
	}
#line 1709 "cfparse.c" /* yacc.c:1652  */
    break;

  case 26:
#line 302 "cfparse.y" /* yacc.c:1652  */
    {
	    if ((yyvsp[0].num) < 2 || (yyvsp[0].num) > 10)
		fatal("Invalid IGMP robustness value [2,10]: %d", (yyvsp[0].num));
	    igmp_robustness = (yyvsp[0].num);
	}
#line 1719 "cfparse.c" /* yacc.c:1652  */
    break;

  case 30:
#line 315 "cfparse.y" /* yacc.c:1652  */
    {
	    v->uv_flags |= VIFF_OTUNNEL;
	}
#line 1727 "cfparse.c" /* yacc.c:1652  */
    break;

  case 31:
#line 319 "cfparse.y" /* yacc.c:1652  */
    {
	    if ((yyvsp[0].num))
		v->uv_flags |= VIFF_OTUNNEL;
	    else
		v->uv_flags &= ~VIFF_OTUNNEL;
	}
#line 1738 "cfparse.c" /* yacc.c:1652  */
    break;

  case 32:
#line 326 "cfparse.y" /* yacc.c:1652  */
    {
	    fatal("Source-route tunnels not supported");
	}
#line 1746 "cfparse.c" /* yacc.c:1652  */
    break;

  case 36:
#line 336 "cfparse.y" /* yacc.c:1652  */
    { v->uv_flags |= VIFF_DISABLED; }
#line 1752 "cfparse.c" /* yacc.c:1652  */
    break;

  case 37:
#line 337 "cfparse.y" /* yacc.c:1652  */
    { v->uv_flags &= ~VIFF_DISABLED; }
#line 1758 "cfparse.c" /* yacc.c:1652  */
    break;

  case 38:
#line 338 "cfparse.y" /* yacc.c:1652  */
    { v->uv_flags &= ~VIFF_IGMPV2; v->uv_flags |= VIFF_IGMPV1; }
#line 1764 "cfparse.c" /* yacc.c:1652  */
    break;

  case 39:
#line 339 "cfparse.y" /* yacc.c:1652  */
    { v->uv_flags &= ~VIFF_IGMPV1; v->uv_flags |= VIFF_IGMPV2; }
#line 1770 "cfparse.c" /* yacc.c:1652  */
    break;

  case 40:
#line 340 "cfparse.y" /* yacc.c:1652  */
    { v->uv_flags &= ~VIFF_IGMPV1; v->uv_flags &= ~VIFF_IGMPV2; }
#line 1776 "cfparse.c" /* yacc.c:1652  */
    break;

  case 41:
#line 342 "cfparse.y" /* yacc.c:1652  */
    {
	    uint32_t subnet, mask;

	    mask = (yyvsp[0].addr);
	    subnet = v->uv_lcl_addr & mask;
	    if (!inet_valid_subnet(subnet, mask))
		fatal("Invalid netmask");
	    v->uv_subnet = subnet;
	    v->uv_subnetmask = mask;
	    v->uv_subnetbcast = subnet | ~mask;
	}
#line 1792 "cfparse.c" /* yacc.c:1652  */
    break;

  case 42:
#line 354 "cfparse.y" /* yacc.c:1652  */
    {
	    warn("Expected address after netmask keyword, ignored");
	}
#line 1800 "cfparse.c" /* yacc.c:1652  */
    break;

  case 43:
#line 358 "cfparse.y" /* yacc.c:1652  */
    {
	    struct phaddr *ph;

	    ph = calloc(1, sizeof(struct phaddr));
	    if (!ph) {
		fatal("Failed allocating memory for 'struct phaddr'");
		return 0;
	    }

	    if ((yyvsp[0].addrmask).mask)
		VAL_TO_MASK(ph->pa_subnetmask, (yyvsp[0].addrmask).mask);
	    else
		ph->pa_subnetmask = v->uv_subnetmask;

	    ph->pa_subnet = (yyvsp[0].addrmask).addr & ph->pa_subnetmask;
	    ph->pa_subnetbcast = ph->pa_subnet | ~ph->pa_subnetmask;

	    if ((yyvsp[0].addrmask).addr & ~ph->pa_subnetmask)
		warn("Extra subnet %s/%d has host bits set",
		     inet_fmt((yyvsp[0].addrmask).addr, s1, sizeof(s1)), (yyvsp[0].addrmask).mask);

	    ph->pa_next = v->uv_addrs;
	    v->uv_addrs = ph;
	}
#line 1829 "cfparse.c" /* yacc.c:1652  */
    break;

  case 44:
#line 383 "cfparse.y" /* yacc.c:1652  */
    {
	    warn("Expected address after altnet keyword, ignored");
	}
#line 1837 "cfparse.c" /* yacc.c:1652  */
    break;

  case 45:
#line 387 "cfparse.y" /* yacc.c:1652  */
    {
	    v->uv_flags |= VIFF_FORCE_LEAF;
	}
#line 1845 "cfparse.c" /* yacc.c:1652  */
    break;

  case 46:
#line 391 "cfparse.y" /* yacc.c:1652  */
    {
	    if ((yyvsp[0].num))
		v->uv_flags |= VIFF_FORCE_LEAF;
	    else
		v->uv_flags &= ~VIFF_FORCE_LEAF;
	}
#line 1856 "cfparse.c" /* yacc.c:1652  */
    break;

  case 47:
#line 400 "cfparse.y" /* yacc.c:1652  */
    {
	    if ((yyvsp[0].num) < 1 || (yyvsp[0].num) > 255)
		fatal("Invalid threshold %d",(yyvsp[0].num));
	    v->uv_threshold = (yyvsp[0].num);
	}
#line 1866 "cfparse.c" /* yacc.c:1652  */
    break;

  case 48:
#line 406 "cfparse.y" /* yacc.c:1652  */
    {
	    warn("Expected number after threshold keyword, ignored");
	}
#line 1874 "cfparse.c" /* yacc.c:1652  */
    break;

  case 49:
#line 410 "cfparse.y" /* yacc.c:1652  */
    {
	    if ((yyvsp[0].num) < 1 || (yyvsp[0].num) > UNREACHABLE)
		fatal("Invalid metric %d",(yyvsp[0].num));
	    v->uv_metric = (yyvsp[0].num);
	}
#line 1884 "cfparse.c" /* yacc.c:1652  */
    break;

  case 50:
#line 416 "cfparse.y" /* yacc.c:1652  */
    {
	    warn("Expected number after metric keyword, ignored");
	}
#line 1892 "cfparse.c" /* yacc.c:1652  */
    break;

  case 51:
#line 420 "cfparse.y" /* yacc.c:1652  */
    {
	    if ((yyvsp[0].num) < 0 || (yyvsp[0].num) > UNREACHABLE - 1)
		fatal("Invalid advert-metric %d", (yyvsp[0].num));
	    v->uv_admetric = (yyvsp[0].num);
	}
#line 1902 "cfparse.c" /* yacc.c:1652  */
    break;

  case 52:
#line 426 "cfparse.y" /* yacc.c:1652  */
    {
	    warn("Expected number after advert_metric keyword, ignored");
	}
#line 1910 "cfparse.c" /* yacc.c:1652  */
    break;

  case 53:
#line 430 "cfparse.y" /* yacc.c:1652  */
    {
	    if ((yyvsp[0].num) > MAX_RATE_LIMIT)
		fatal("Invalid rate-limit %d",(yyvsp[0].num));
	    v->uv_rate_limit = (yyvsp[0].num);
	}
#line 1920 "cfparse.c" /* yacc.c:1652  */
    break;

  case 54:
#line 436 "cfparse.y" /* yacc.c:1652  */
    {
	    warn("Expected number after rate_limit keyword, ignored");
	}
#line 1928 "cfparse.c" /* yacc.c:1652  */
    break;

  case 55:
#line 440 "cfparse.y" /* yacc.c:1652  */
    {
	    struct vif_acl *v_acl;

	    v_acl = calloc(1, sizeof(struct vif_acl));
	    if (!v_acl) {
		fatal("Failed allocating memory for 'struct vif_acl'");
		return 0;
	    }

	    VAL_TO_MASK(v_acl->acl_mask, (yyvsp[0].addrmask).mask);
	    v_acl->acl_addr = (yyvsp[0].addrmask).addr & v_acl->acl_mask;
	    if ((yyvsp[0].addrmask).addr & ~v_acl->acl_mask)
		warn("Boundary spec %s/%d has host bits set",
		     inet_fmt((yyvsp[0].addrmask).addr, s1, sizeof(s1)), (yyvsp[0].addrmask).mask);
	    v_acl->acl_next = v->uv_acl;
	    v->uv_acl = v_acl;
	}
#line 1950 "cfparse.c" /* yacc.c:1652  */
    break;

  case 56:
#line 458 "cfparse.y" /* yacc.c:1652  */
    {
	    warn("Expected boundary spec after boundary keyword, ignored");
	}
#line 1958 "cfparse.c" /* yacc.c:1652  */
    break;

  case 57:
#line 462 "cfparse.y" /* yacc.c:1652  */
    {
	    v->uv_flags |= VIFF_REXMIT_PRUNES;
	}
#line 1966 "cfparse.c" /* yacc.c:1652  */
    break;

  case 58:
#line 466 "cfparse.y" /* yacc.c:1652  */
    {
	    if ((yyvsp[0].num))
		v->uv_flags |= VIFF_REXMIT_PRUNES;
	    else
		v->uv_flags &= ~VIFF_REXMIT_PRUNES;
	}
#line 1977 "cfparse.c" /* yacc.c:1652  */
    break;

  case 59:
#line 473 "cfparse.y" /* yacc.c:1652  */
    {
	    v->uv_flags |= VIFF_PASSIVE;
	}
#line 1985 "cfparse.c" /* yacc.c:1652  */
    break;

  case 60:
#line 477 "cfparse.y" /* yacc.c:1652  */
    {
	    v->uv_flags |= VIFF_NOFLOOD;
	}
#line 1993 "cfparse.c" /* yacc.c:1652  */
    break;

  case 61:
#line 481 "cfparse.y" /* yacc.c:1652  */
    {
	    v->uv_flags |= VIFF_NOTRANSIT;
	}
#line 2001 "cfparse.c" /* yacc.c:1652  */
    break;

  case 62:
#line 485 "cfparse.y" /* yacc.c:1652  */
    {
	    v->uv_flags |= VIFF_BLASTER;
	    blaster_alloc(v - uvifs);
	}
#line 2010 "cfparse.c" /* yacc.c:1652  */
    break;

  case 63:
#line 490 "cfparse.y" /* yacc.c:1652  */
    {
	    v->uv_flags |= VIFF_ALLOW_NONPRUNERS;
	}
#line 2018 "cfparse.c" /* yacc.c:1652  */
    break;

  case 64:
#line 494 "cfparse.y" /* yacc.c:1652  */
    {
	    if ((yyvsp[0].num) < MIN_PRUNE_LIFETIME)
		warn("prune-lifetime %d must be at least %d", (yyvsp[0].num), MIN_PRUNE_LIFETIME);
	    else
		v->uv_prune_lifetime = (yyvsp[0].num);
	}
#line 2029 "cfparse.c" /* yacc.c:1652  */
    break;

  case 65:
#line 501 "cfparse.y" /* yacc.c:1652  */
    {
	    if (v->uv_filter == NULL) {
		struct vif_filter *v_filter;

		v_filter = calloc(1, sizeof(struct vif_filter));
		if (!v_filter) {
		    fatal("Failed allocating memory for 'struct vif_filter'");
		    return 0;
		}

		v_filter->vf_flags  = 0;
		v_filter->vf_type   = VFT_ACCEPT;
		v_filter->vf_filter = (yyvsp[0].filterelem);

		v->uv_filter = v_filter;
	    } else if (v->uv_filter->vf_type != VFT_ACCEPT) {
		fatal("Cannot accept and deny");
	    } else {
		struct vf_element *p;

		p = v->uv_filter->vf_filter;
		while (p->vfe_next)
		    p = p->vfe_next;
		p->vfe_next = (yyvsp[0].filterelem);
	    }
	}
#line 2060 "cfparse.c" /* yacc.c:1652  */
    break;

  case 66:
#line 528 "cfparse.y" /* yacc.c:1652  */
    {
	    warn("Expected filter spec after accept keyword, ignored");
	}
#line 2068 "cfparse.c" /* yacc.c:1652  */
    break;

  case 67:
#line 532 "cfparse.y" /* yacc.c:1652  */
    {
	    if (!v->uv_filter) {
		struct vif_filter *v_filter;

		v_filter = calloc(1, sizeof(struct vif_filter));
		if (!v_filter) {
		    fatal("Failed allocating memory for 'struct vif_filter'");
		    return 0;
		}

		v_filter->vf_flags  = 0;
		v_filter->vf_type   = VFT_DENY;
		v_filter->vf_filter = (yyvsp[0].filterelem);

		v->uv_filter = v_filter;
	    } else if (v->uv_filter->vf_type != VFT_DENY) {
		fatal("Cannot accept and deny");
	    } else {
		struct vf_element *p;

		p = v->uv_filter->vf_filter;
		while (p->vfe_next)
		    p = p->vfe_next;
		p->vfe_next = (yyvsp[0].filterelem);
	    }
	}
#line 2099 "cfparse.c" /* yacc.c:1652  */
    break;

  case 68:
#line 559 "cfparse.y" /* yacc.c:1652  */
    {
		warn("Expected filter spec after deny keyword, ignored");
	}
#line 2107 "cfparse.c" /* yacc.c:1652  */
    break;

  case 69:
#line 563 "cfparse.y" /* yacc.c:1652  */
    {
	    if (!v->uv_filter) {
		fatal("bidir goes after filters");
		return 0;	/* Never reached */
	    }
	    v->uv_filter->vf_flags |= VFF_BIDIR;
	}
#line 2119 "cfparse.c" /* yacc.c:1652  */
    break;

  case 70:
#line 573 "cfparse.y" /* yacc.c:1652  */
    {
	    (yyval.addr) = (yyvsp[0].addr);
	}
#line 2127 "cfparse.c" /* yacc.c:1652  */
    break;

  case 71:
#line 577 "cfparse.y" /* yacc.c:1652  */
    {
	    (yyval.addr) = valid_if((yyvsp[0].ptr));
	    if ((yyval.addr) == 0)
		warn("phyint %s not available, continuing ...", (yyvsp[0].ptr));
	}
#line 2137 "cfparse.c" /* yacc.c:1652  */
    break;

  case 72:
#line 585 "cfparse.y" /* yacc.c:1652  */
    {
	    (yyval.addr) = (yyvsp[0].addr);
	}
#line 2145 "cfparse.c" /* yacc.c:1652  */
    break;

  case 73:
#line 589 "cfparse.y" /* yacc.c:1652  */
    {
	    struct sockaddr_in *sin;
	    struct addrinfo *result;
	    struct addrinfo hints;
	    int rc;

	    memset(&hints, 0, sizeof(struct addrinfo));
	    hints.ai_family = AF_INET;
	    hints.ai_socktype = SOCK_DGRAM;

	    rc = getaddrinfo((yyvsp[0].ptr), NULL, &hints, &result);
	    if (rc) {
		fatal("No such host %s", (yyvsp[0].ptr));
		return 0;	/* Never reached */
	    }

	    if (result->ai_next)
		fatal("Hostname %s does not %s", (yyvsp[0].ptr), "map to a unique address");

	    sin = (struct sockaddr_in *)result->ai_addr;
	    (yyval.addr)  = sin->sin_addr.s_addr;

	    freeaddrinfo(result);
	}
#line 2174 "cfparse.c" /* yacc.c:1652  */
    break;

  case 74:
#line 615 "cfparse.y" /* yacc.c:1652  */
    {
	    (yyval.addrmask) = (yyvsp[0].addrmask);
	}
#line 2182 "cfparse.c" /* yacc.c:1652  */
    break;

  case 75:
#line 619 "cfparse.y" /* yacc.c:1652  */
    {
	    int i;

	    for (i=0; i < numbounds; i++) {
		if (!strcmp(boundlist[i].name, (yyvsp[0].ptr))) {
		    (yyval.addrmask) = boundlist[i].bound;
		    break;
		}
	    }

	    if (i == numbounds)
		fatal("Invalid boundary name %s", (yyvsp[0].ptr));
	}
#line 2200 "cfparse.c" /* yacc.c:1652  */
    break;

  case 76:
#line 635 "cfparse.y" /* yacc.c:1652  */
    {
#ifdef ALLOW_BLACK_HOLES
	    if (!allow_black_holes)
#endif
		if ((ntohl((yyvsp[0].addrmask).addr) & 0xff000000) != 0xef000000) {
		    fatal("Boundaries must be 239.x.x.x, not %s/%d",
			  inet_fmt((yyvsp[0].addrmask).addr, s1, sizeof(s1)), (yyvsp[0].addrmask).mask);
		}
	    (yyval.addrmask) = (yyvsp[0].addrmask);
	}
#line 2215 "cfparse.c" /* yacc.c:1652  */
    break;

  case 77:
#line 647 "cfparse.y" /* yacc.c:1652  */
    { (yyval.addrmask) = (yyvsp[0].addrmask); }
#line 2221 "cfparse.c" /* yacc.c:1652  */
    break;

  case 78:
#line 648 "cfparse.y" /* yacc.c:1652  */
    { (yyval.addrmask).addr = (yyvsp[0].addr); (yyval.addrmask).mask = 0; }
#line 2227 "cfparse.c" /* yacc.c:1652  */
    break;

  case 79:
#line 651 "cfparse.y" /* yacc.c:1652  */
    { (yyval.filterelem) = (yyvsp[0].filterelem); }
#line 2233 "cfparse.c" /* yacc.c:1652  */
    break;

  case 80:
#line 652 "cfparse.y" /* yacc.c:1652  */
    { fatal("named filters no implemented yet"); }
#line 2239 "cfparse.c" /* yacc.c:1652  */
    break;

  case 81:
#line 655 "cfparse.y" /* yacc.c:1652  */
    { (yyval.filterelem) = (yyvsp[0].filterelem); }
#line 2245 "cfparse.c" /* yacc.c:1652  */
    break;

  case 82:
#line 656 "cfparse.y" /* yacc.c:1652  */
    { (yyvsp[-1].filterelem)->vfe_next = (yyvsp[0].filterelem); (yyval.filterelem) = (yyvsp[-1].filterelem); }
#line 2251 "cfparse.c" /* yacc.c:1652  */
    break;

  case 83:
#line 659 "cfparse.y" /* yacc.c:1652  */
    { (yyval.filterelem) = (yyvsp[0].filterelem); }
#line 2257 "cfparse.c" /* yacc.c:1652  */
    break;

  case 84:
#line 660 "cfparse.y" /* yacc.c:1652  */
    { (yyvsp[-1].filterelem)->vfe_flags |= VFEF_EXACT; (yyval.filterelem) = (yyvsp[-1].filterelem); }
#line 2263 "cfparse.c" /* yacc.c:1652  */
    break;

  case 85:
#line 664 "cfparse.y" /* yacc.c:1652  */
    {
	    struct vf_element *vfe;

	    vfe = calloc(1, sizeof(struct vf_element));
	    if (!vfe) {
		fatal("Failed allocating memory for 'struct vf_element'");
		return 0;
	    }

	    vfe->vfe_addr = (yyvsp[0].addrmask).addr;
	    VAL_TO_MASK(vfe->vfe_mask, (yyvsp[0].addrmask).mask);
	    vfe->vfe_flags = 0;
	    vfe->vfe_next = NULL;

	    (yyval.filterelem) = vfe;
	}
#line 2284 "cfparse.c" /* yacc.c:1652  */
    break;


#line 2288 "cfparse.c" /* yacc.c:1652  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;


#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif


/*-----------------------------------------------------.
| yyreturn -- parsing is finished, return the result.  |
`-----------------------------------------------------*/
yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 680 "cfparse.y" /* yacc.c:1918  */

static void fatal(const char *fmt, ...)
{
    va_list ap;
    char buf[MAXHOSTNAMELEN + 100];

    va_start(ap, fmt);
    vsnprintf(buf, sizeof(buf), fmt, ap);
    va_end(ap);

    logit(LOG_ERR, 0, "%s:%d: %s", configfilename, lineno, buf);
}

static void warn(const char *fmt, ...)
{
    va_list ap;
    char buf[200];

    va_start(ap, fmt);
    vsnprintf(buf, sizeof(buf), fmt, ap);
    va_end(ap);

    logit(LOG_WARNING, 0, "%s:%d: %s", configfilename, lineno, buf);
}

static void yyerror(char *msg)
{
    logit(LOG_ERR, 0, "%s:%d: %s", configfilename, lineno, msg);
}

static char *next_word(void)
{
    static char buf[1024];
    static char *p = NULL;
    char *q;

    while (1) {
        if (!p || !*p) {
            lineno++;
            if (fgets(buf, sizeof(buf), fp) == NULL)
                return NULL;
            p = buf;
        }

        while (*p && (*p == ' ' || *p == '\t'))	/* skip whitespace */
            p++;

        if (*p == '#') {
            p = NULL;		/* skip comments */
            continue;
        }

        q = p;
        while (*p && *p != ' ' && *p != '\t' && *p != '\n')
            p++;		/* find next whitespace */
        *p++ = '\0';	/* null-terminate string */

        if (!*q) {
            p = NULL;
            continue;	/* if 0-length string, read another line */
        }

        return q;
    }
}

/*
 * List of keywords.  Must have an empty record at the end to terminate
 * list.  If a second value is specified, the first is used at the beginning
 * of the file and the second is used while parsing interfaces (e.g. after
 * the first "phyint" or "tunnel" keyword).
 */
static struct keyword {
	char	*word;
	int	val1;
	int	val2;
} words[] = {
	{ "cache_lifetime",	CACHE_LIFETIME, 0 },
	{ "cache-lifetime",	CACHE_LIFETIME, 0 },
	{ "prune_lifetime",	PRUNE_LIFETIME,	PRUNE_LIFETIME2 },
	{ "prune-lifetime",	PRUNE_LIFETIME,	PRUNE_LIFETIME2 },
	{ "igmp-query-interval", QUERY_INTERVAL, 0 },
	{ "igmp-robustness",    IGMP_ROBUSTNESS, 0 },
	{ "no",                 NO, 0 },
	{ "pruning",		PRUNING, 0 },
	{ "phyint",		PHYINT, 0 },
	{ "tunnel",		TUNNEL, 0 },
	{ "disable",		DISABLE, 0 },
	{ "enable",		ENABLE, 0 },
	{ "metric",		METRIC, 0 },
	{ "advert_metric",	ADVERT_METRIC, 0 },
	{ "advert-metric",	ADVERT_METRIC, 0 },
	{ "threshold",		THRESHOLD, 0 },
	{ "rate_limit",		RATE_LIMIT, 0 },
	{ "rate-limit",		RATE_LIMIT, 0 },
	{ "force_leaf",		FORCE_LEAF, 0 },
	{ "force-leaf",		FORCE_LEAF, 0 },
	{ "router-alert",	ROUTER_ALERT, 0 },
	{ "srcrt",		SRCRT, 0 },
	{ "sourceroute",	SRCRT, 0 },
	{ "boundary",		BOUNDARY, 0 },
	{ "netmask",		NETMASK, 0 },
	{ "igmpv1",		IGMPV1, 0 },
	{ "igmpv2",		IGMPV2, 0 },
	{ "igmpv2",		IGMPV3, 0 },
	{ "altnet",		ALTNET, 0 },
	{ "name",		NAME, 0 },
	{ "accept",		ACCEPT, 0 },
	{ "deny",		DENY, 0 },
	{ "exact",		EXACT, 0 },
	{ "bidir",		BIDIR, 0 },
	{ "allow_nonpruners",	ALLOW_NONPRUNERS, 0 },
	{ "allow-nonpruners",	ALLOW_NONPRUNERS, 0 },
#ifdef ALLOW_BLACK_HOLES
	{ "allow_black_holes",	BLACK_HOLE, 0 },
	{ "allow-black-holes",	BLACK_HOLE, 0 },
#endif
	{ "noflood",		NOFLOOD, NOFLOOD2 },
	{ "notransit",		NOTRANSIT, 0 },
	{ "blaster",		BLASTER, 0 },
	{ "rexmit_prunes",	REXMIT_PRUNES, REXMIT_PRUNES2 },
	{ "rexmit-prunes",	REXMIT_PRUNES, REXMIT_PRUNES2 },
	{ "passive",		PASSIVE, 0 },
	{ "beside",		BESIDE, 0 },
#if 0 /* Removed SNMP support */
	{ "sysName",		SYSNAM, 0 },
	{ "sysContact",		SYSCONTACT, 0 },
	{ "sysVersion",		SYSVERSION, 0 },
	{ "sysLocation",	SYSLOCATION, 0 },
#endif
	{ NULL,			0, 0 }
};


static int yylex(void)
{
    struct keyword *w;
    uint32_t addr, n;
    char *q;

    q = next_word();
    if (!q)
        return 0;

    for (w = words; w->word; w++) {
        if (!strcmp(q, w->word))
            return (state && w->val2) ? w->val2 : w->val1;
    }

    if (!strcmp(q,"on") || !strcmp(q,"yes")) {
        yylval.num = 1;
        return BOOLEAN;
    }

    if (!strcmp(q,"off") || !strcmp(q,"no")) {
        yylval.num = 0;
        return BOOLEAN;
    }

    if (!strcmp(q,"default")) {
        yylval.addrmask.mask = 0;
        yylval.addrmask.addr = 0;
        return ADDRMASK;
    }

    if (sscanf(q,"%[.0-9]/%u%c",s1,&n,s2) == 2) {
	addr = inet_parse(s1,1);
        if (addr != 0xffffffff) {
            yylval.addrmask.mask = n;
            yylval.addrmask.addr = addr;
            return ADDRMASK;
        }
        /* fall through to returning STRING */
    }

    if (sscanf(q,"%[.0-9]%c",s1,s2) == 1) {
	addr = inet_parse(s1,4);
        if (addr != 0xffffffff && inet_valid_host(addr)) {
            yylval.addr = addr;
            return ADDR;
        }
    }

    if (sscanf(q,"0x%8x%c", &n, s1) == 1) {
        yylval.addr = n;
        return ADDR;
    }

    if (sscanf(q,"%u%c",&n,s1) == 1) {
        yylval.num = n;
        return NUMBER;
    }

    yylval.ptr = q;

    return STRING;
}

void config_vifs_from_file(void)
{
    order = 0;
    state = 0;
    numbounds = 0;
    lineno = 0;

    fp = fopen(configfilename, "r");
    if (!fp) {
        if (errno != ENOENT)
            logit(LOG_ERR, errno, "Cannot open %s", configfilename);
        return;
    }

    yyparse();

    fclose(fp);
}

static uint32_t valid_if(char *s)
{
    struct uvif *v;
    vifi_t vifi;

    if (!s)
	return 0;

    for (vifi = 0, v = uvifs; vifi < numvifs; vifi++, v++) {
        if (!strcmp(v->uv_name, s))
            return v->uv_lcl_addr;
    }

    return 0;
}

static const char *ifconfaddr(uint32_t addr)
{
    struct ifaddrs *ifap, *ifa;
    static char buf[IFNAMSIZ];
    char *ifname = NULL;

    if (getifaddrs(&ifap) != 0)
	return NULL;

    for (ifa = ifap; ifa; ifa = ifa->ifa_next) {
	struct sockaddr_in *sin;

	if (!ifa->ifa_addr)
	    continue;
	if (ifa->ifa_addr->sa_family != AF_INET)
	    continue;

	sin = (struct sockaddr_in *)ifa->ifa_addr;
	if (sin->sin_addr.s_addr != addr)
	    continue;

	strlcpy(buf, ifa->ifa_name, sizeof(buf));
	ifname = buf;
	break;
    }

    freeifaddrs(ifap);

    return ifname;
}

/**
 * Local Variables:
 *  indent-tabs-mode: t
 *  c-file-style: "ellemtel"
 *  c-basic-offset: 4
 * End:
 */
